(defun C:draw_table_hod ( / )
  ;       
  (geo_tools-help "draw_table_hod")
  (load_global_variable)
  (setq flag-angle T)
  (setq list-settings(get-list-serttings-by-table-coord-polyline))
  (initget 1)(setq pline (car (entsel "\n  : ")))
  (cond
    ((eq pline nil)
     (alert "  !"))
    ((not(eq (cdr(assoc 0 (entget pline))) "LWPOLYLINE"))
     (alert "  2D !"))
    ((eq (cdr(assoc 0 (entget pline))) "LWPOLYLINE")
     (vla-StartUndoMark active_document)
     (create-table-style);    
     (create-mleader-style "");  
     (setq 2Dpline_vla (vlax-ename->vla-object pline))
     (setq spisok (extract_coord_lwpolyline (entget pline)))

       (setq t0 (getpoint "\n    : "))

	  (setq table_obj (vla-AddTable model_spece (vlax-3D-point t0) 2 (if (=(get-item-by-name-in-list list-settings"angle-column")1) 6 5) 12 20))
	  (vla-put-StyleName table_obj "")
	  (vla-SetColumnWidth table_obj 0 8)
	  
	  (vla-SetText table_obj 0 0 (vla-get-Layer 2Dpline_vla))
	  (vla-SetCellTextHeight table_obj 0 0 4.0)
	  (vla-SetCellAlignment table_obj 0 0 acMiddleCenter)
	  (vla-SetText table_obj 1 0 "")
	  (vla-SetCellTextHeight table_obj 1 0 2.8)
	  (vla-SetCellAlignment table_obj 1 0 acMiddleCenter)
	  (vla-SetText table_obj 1 1 "")
	  (vla-SetCellAlignment table_obj 1 1 acMiddleLeft)
	  (vla-SetCellTextHeight table_obj 1 1 2.4)
	  (vla-SetText table_obj 1 2 "")
	  (vla-SetCellAlignment table_obj 1 2 acMiddleCenter)
	  (vla-SetCellTextHeight table_obj 1 2 2.8)
	  (vla-SetText table_obj 1 3 "")
	  (vla-SetCellAlignment table_obj 1 3 acMiddleCenter)
	  (vla-SetCellTextHeight table_obj 1 3 2.8)
	  (vla-SetText table_obj 1 4 "\n")
	  (vla-SetCellAlignment table_obj 1 4 acMiddleCenter)
	  (vla-SetCellTextHeight table_obj 1 4 2.8)
       
	  (vla-put-horzcellmargin table_obj 0.5)
	  (vla-put-vertcellmargin table_obj 0.5)
	  (vla-SetRowHeight table_obj 1 12.0)
       

	 (if (=(get-item-by-name-in-list list-settings"mleader-enable")1);            
	   (if (setq nabor (ssget "_X" '((0 . "MULTILEADER"))))
	     (progn
	       (setq leaders_list (convert_ss_to_list nabor))
	       (mapcar '(lambda (x)
			  (setq point_list (vlax-safearray->list(vlax-variant-value(vla-GetLeaderLineVertices (vlax-ename->vla-object x) 0))))
			  (setq point_leaders_list (append point_leaders_list (list (list (car point_list)(cadr point_list)))))
			  )
		       leaders_list)
	       )
	     )
	   )
	 (mapcar '(lambda (x);    
		    (if T ;    
		      (setq num_vinoska (analysis_member_point_in_list_equal x point_leaders_list 0.01));       
		      )
		    (if num_vinoska
		      (progn
			(setq vla_vinoska (vlax-ename->vla-object (nth num_vinoska leaders_list)))
			(if (eq (vla-get-ContentBlockName vla_vinoska) "")
			  (setq diskription (vla-get-TextString vla_vinoska))
			  (setq diskription (strcat
					      (if (=(get-item-by-name-in-list list-settings"add-perfix-to-mleader")1)
						(get-item-by-name-in-list list-settings"perfix")
						""
						)
					      (cadr(extract_302 (entget (nth num_vinoska leaders_list)))))))
			)
		      (progn
			(setq diskription "")
			(setvar "CMLEADERSTYLE" "")
			(cond
			  ((eq (vl-position x spisok) 0) ;    
			   (setq pt_array (convert_coords_list_from_safearray_mleader (list x (polar x (angle (nth (1+(vl-position x spisok))spisok) x)(/ 10 (getvar "CANNOSCALEVALUE"))))))
			   (setq mleader_obj (vla-addmleader model_spece pt_array 0))
			   (vla-put-StyleName mleader_obj "")
			   (vla-put-textstring mleader_obj (itoa nn))
			   (vla-put-TextHeight mleader_obj (/ 3 (getvar "CANNOSCALEVALUE")))
			   (vla-put-ArrowheadType mleader_obj 12)
			   (vla-put-ArrowheadSize mleader_obj (/ 1.5 (getvar "CANNOSCALEVALUE")))
			   (vla-put-ArrowheadBlock mleader_obj "_DotBlank")
			   )
			  ((eq (vl-position x spisok) (1-(length spisok)));    
			   (setq pt_array (convert_coords_list_from_safearray_mleader (list x (polar x (angle (nth (1-(vl-position x spisok))spisok) x)(/ 10 (getvar "CANNOSCALEVALUE"))))))
			   (setq mleader_obj (vla-addmleader model_spece pt_array 0))
			   (vla-put-StyleName mleader_obj "")
			   (vla-put-textstring mleader_obj (itoa nn))
			   (vla-put-TextHeight mleader_obj (/ 3 (getvar "CANNOSCALEVALUE")))
			   (vla-put-ArrowheadType mleader_obj 12)
			   (vla-put-ArrowheadSize mleader_obj (/ 1.5 (getvar "CANNOSCALEVALUE")))
			   (vla-put-ArrowheadBlock mleader_obj "_DotBlank")
			   )
			  (T ;    
			   (setq p1(nth(1-(vl-position x spisok))spisok))
			   (setq p3(nth(1+(vl-position x spisok))spisok))
			   (cond
			     ((> (calculation_angle_be_3points p1 x p3) (calculation_angle_be_3points p3 x p1))
			      (setq p (polar x (+(angle x p3) (/(calculation_angle_be_3points p1 x p3)2)) (/ 10 (getvar "CANNOSCALEVALUE")))))
			     ((< (calculation_angle_be_3points p1 x p3) (calculation_angle_be_3points p3 x p1))
			      (setq p (polar x (+(angle x p1) (/(calculation_angle_be_3points p3 x p1)2)) (/ 10 (getvar "CANNOSCALEVALUE")))))
			     ((= (calculation_angle_be_3points p1 x p3) (calculation_angle_be_3points p3 x p1))
			      (setq p (polar x (+(angle x p3) (/ pi 2)) (/ 10 (getvar "CANNOSCALEVALUE"))))))
			   
			   (setq pt_array (convert_coords_list_from_safearray_mleader (list x p)))
			   (setq mleader_obj (vla-addmleader model_spece pt_array 0))
			   (vla-put-StyleName mleader_obj "")
			   (vla-put-textstring mleader_obj (itoa nn))
			   (vla-put-TextHeight mleader_obj (/ 3 (getvar "CANNOSCALEVALUE")))
			   
			   (vla-put-ArrowheadType mleader_obj 12)
			   (vla-put-ArrowheadSize mleader_obj (/ 1.5 (getvar "CANNOSCALEVALUE")))
			   (vla-put-ArrowheadBlock mleader_obj "_DotBlank")
			   )
			  )
			)
		      )
		    (setq diskription_list (append diskription_list (list diskription)))
		    (setq num_row (vla-get-rows table_obj))
		    (vla-InsertRows table_obj (1+ num_row) 4 2)
		    (vla-SetRowHeight table_obj (1+ num_row) 5.2)
		    (vla-mergeCells table_obj num_row (1+ num_row) 0 0)
		    (vla-mergeCells table_obj num_row (1+ num_row) 1 1)
		    (vla-mergeCells table_obj num_row (1+ num_row) 2 2)
		    (vla-mergeCells table_obj num_row (1+ num_row) 3 3)
		    (vla-SetText table_obj num_row 0 (rtos nn 2 0))
		    (vla-SetCellAlignment table_obj num_row 0 acMiddleCenter)
		    (vla-SetCellTextHeight table_obj num_row 0 2.8)
		    (vla-SetText table_obj num_row 1 diskription)
		    (vla-SetCellAlignment table_obj num_row 1 acMiddleLeft)
		    (vla-SetCellTextHeight table_obj num_row 1 2.4)
		    (vla-SetText table_obj num_row 2 (rtos (nth 1 x) 2 (get-item-by-name-in-list list-settings"accuracy-coordinate")))
		    (vla-SetCellAlignment table_obj num_row 2 acMiddleCenter)
		    (vla-SetCellTextHeight table_obj num_row 2 2.8)
		    (vla-SetText table_obj num_row 3 (rtos (nth 0 x) 2 (get-item-by-name-in-list list-settings"accuracy-coordinate")))
		    (vla-SetCellAlignment table_obj num_row 3 acMiddleCenter)
		    (vla-SetCellTextHeight table_obj num_row 3 2.8)
		    (vla-SetRowHeight table_obj (1+ num_row) 5.0)
		    (vla-SetRowHeight table_obj num_row 5.0)
		    (if (not(eq (vl-position x spisok) 0))
		      (progn
			(vla-mergeCells table_obj (1- num_row) num_row 4 4)
			(vla-SetCellAlignment table_obj (1- num_row) 4 acMiddleCenter)
			(vla-SetCellTextHeight table_obj (1- num_row) 4 2.8)
			(vla-SetText table_obj (1- num_row) 4 (rtos(distance x(nth (1-(vl-position x spisok))spisok))2 (get-item-by-name-in-list list-settings"accuracy-coordinate")))
			))
		    (if (=(get-item-by-name-in-list list-settings"angle-column")1)
		      (progn
			(if(or(eq (vl-position x spisok) 0)(eq (vl-position x spisok) (1-(length spisok)))) ;         
			  (setq string "-----")
			  (progn
			    (setq p1(nth(1-(vl-position x spisok))spisok))
			    (setq p3(nth(1+(vl-position x spisok))spisok))
			    (setq angle-l (convert-rad-grad(-(calculation_angle_be_3points p1 x p3)pi)))
			    (setq string (strcat (if (minusp angle-l) "" "") " " (vl-string-subst"%%d" "d"(convert-dec-to-gms-str (abs angle-l) 2)0)))
			    )
			  )
			(vla-mergeCells table_obj num_row (1+ num_row) 5 5)
			(vla-SetText table_obj num_row 5 string)
			(vla-SetCellAlignment table_obj num_row 5 acMiddleCenter)
			(vla-SetCellTextHeight table_obj num_row 5 2.8)
			)
		      )
		    (setq nn (1+ nn))
		    )
		 spisok)

	 (setq num_row (vla-get-rows table_obj))
	 (vla-InsertRows table_obj (1+ num_row) 8 1)
	 (vla-mergeCells table_obj num_row num_row 0 3)
	 (vla-mergeCells table_obj (1- num_row) num_row 4 4)
	 (vla-SetText table_obj (1- num_row) 4 (strcat "\U+03A3L="(rtos (vlax-curve-getDistAtPoint 2Dpline_vla (vlax-curve-getEndPoint 2Dpline_vla)) 2 (get-item-by-name-in-list list-settings"accuracy-coordinate")) ""))
	 (vla-SetCellTextHeight table_obj (1- num_row) 4 2.4)
	 (vla-SetCellAlignment table_obj (1- num_row) 4 acMiddleCenter)
	 (vla-SetText table_obj num_row 0 (strcat "  = "(rtos (vlax-curve-getDistAtPoint 2Dpline_vla (vlax-curve-getEndPoint 2Dpline_vla)) 2 (get-item-by-name-in-list list-settings"accuracy-coordinate")) ""))
	 (vla-SetCellTextHeight table_obj num_row 0 2.8)
	 (vla-SetRowHeight table_obj num_row 8.0)
	 (vla-SetCellAlignment table_obj num_row 0 acMiddleCenter)
	 )
       )
     (vla-EndUndoMark active_document)
  (princ)
  )