(defun C:convert_ii_skv_to_cogo_point_by_surfese (/ ENT-OBJ INSERT-POINT LIST-ALL-ATTS POINT-OBJ ssnabor block-list x 3Dpline)
  (setq 3Dpline (car (entsel "\n : ")))
  (if (eq (cdr(assoc 0 (entget 3Dpline))) "AECC_TIN_SURFACE")
    (progn
      (setq 3Dpline (vlax-ename->vla-object 3Dpline))
      
      (setq ssnabor (ssget '((0 . "INSERT"))))
      (setq block-list (convert_ss_to_list ssnabor))
      (foreach x block-list
	(setq insert-point (cdr(assoc 10 (entget x))))
	(setq insert-point (get-elevation-by-XY-in-surfese_ 3Dpline insert-point))
	(setq list-all-atts (get-all-atts x))
	(setq point-obj (vla-add C3D_points
				 (vlax-3d-point
				   (nth 0 insert-point)
				   (nth 1 insert-point)
				   (nth 2 insert-point))))
	(vlax-put-property point-obj 'Description (cdr(assoc "NUMBER" list-all-atts)))
	(if (cdr(assoc 62 (entget x)))
	  (vlax-put-property point-obj 'color (cdr(assoc 62 (entget x))))
	  )
	(entdel x)
	)
      )
    )
  (princ)
  )