(defun C:draw_mleader_by_2cogo_points (/ POINT POINT-1 POINT-2)
  (if (setq point-1 (car (entsel "\n  cogo-: ")))
    (if (setq point-2 (car (entsel "\n  cogo-: ")))
      (if (and (eq (cdr(assoc 0 (entget point-1))) "AECC_COGO_POINT")(eq (cdr(assoc 0 (entget point-2))) "AECC_COGO_POINT"))
	(progn
	  (setq point (list (vlax-get-property  (vlax-ename->vla-object point-1) "EASTING")(vlax-get-property  (vlax-ename->vla-object point-1) "NORTHING") 0.0))
	  (draw-mleader-vla-by-list-property
	    (list(cons "StyleName" "")
		 (cons "TextStyleName" (getvar "TEXTSTYLE"))
		 (cons "spece" (if (eq (getvar "CTAB")"Model")model_spece paper_spece))
		 (cons "LeaderLineCoor" (list point(mapcar '+ point (list(/ -10 (getvar "CANNOSCALEVALUE")) (/ 10 (getvar "CANNOSCALEVALUE"))))))
		 (cons "TextHeight" (/ 2.0 (getvar "CANNOSCALEVALUE")))
		 (cons "TextString" (strcat (rtos (vlax-get-property  (vlax-ename->vla-object point-1) "ELEVATION")2 2)
					    "\\P"
					    (rtos (vlax-get-property  (vlax-ename->vla-object point-2) "ELEVATION")2 2)))
		 (cons "TextRotation"0.000)
		 ;;;	 (cons "TextLineSpacingStyle" 2)
		 )
	    )
	  )
	(alert "  cogo-!")
	)
      )
    )
  (princ)
  )



  
  
  
