(defun C:import-txt-to-polyline (/ put-file point-bl-coor-list point-coor point-obj dialog-var lst-point-coor)
  ; 
  (if(setq put-file (getfiled "  " (getvar "DWGPREFIX")  "txt" 0))
    (progn
      (create-or-sel-layer (vl-filename-base put-file))
      (princ(setq point-bl-coor-list(get-txt-point-coor put-file)))
      (setq dialog-var(dialog-print_to_png_area))
      (foreach x point-bl-coor-list
	(setq point-coor(convert-bl-wgs-84-to-xy-by-property dialog-var (list (nth 2 x)(nth 1 x))))
	(setq lst-point-coor (append lst-point-coor (list point-coor)))
	)
      (draw-lwpolyline-vla-by-list-property
	(list(cons "spece" (if (eq (getvar "CTAB")"Model")model_spece paper_spece))
	     (cons "Coordinates" lst-point-coor)
	     (cons "Layer"(vl-filename-base put-file))
	     (cons "Closed" -1)
	     ))
      )
    )
  (princ)
  )