(defun analisis-nomenclature-full-for-m500-msk-saratov (t1 /
							n e x y str-list kol-list
							n-5000 e-5000 n-current e-current
							nam1 nam2 nam3 nam4
							n-2000 e-2000
							n-usl e-usl
							d-e-2000-5000 d-n-2000-5000
							)
  ;     .   500       

  (setq e (nth 0 t1))
  (setq n (nth 1 t1))
  (setq e-usl (+ e 100000.0))
  (setq n-usl (+ n 100000.0))

  (if (or (> e-usl 109750.0)(< e-usl 84000.0)(> n-usl 115750.0)(< n-usl 84000.0))
    ""
    (progn
      (setq str-list (list "A" "" "" "" "" "" "" "" "" "" "" "" "" "" "" ""))
      (setq kol-list (list "I" "II" "III" "IV" "V" "VI" "VII" "VIII" "IX" "X" "XI" "XII" "XIII"))
      (setq e-5000 (*(fix (/ e-usl 2000.0))2000.0))
      (setq n-5000 (*(fix (/ n-usl 2000.0))2000.0))

      (setq n-current 114000.0)
      (foreach x str-list
	(if (eq n-current n-5000)
	  (progn(setq nam1 x))
	  )
	(setq n-current (- n-current 2000.0))
	)
      
      (setq e-current 84000.0)
      (foreach y kol-list
	(if (eq e-current e-5000)
	  (setq nam2 y)
	  )
	(setq e-current (+ e-current 2000.0))
	)
      
      (setq e-2000 (*(fix (/ e-usl 1000.0))1000.0))
      (setq n-2000 (*(fix (/ n-usl 1000.0))1000.0))
      (setq d-e-2000-5000 (abs(- e-2000 e-5000)))
      (setq d-n-2000-5000 (abs(- n-2000 n-5000)))
      
      (cond
	((and (eq d-e-2000-5000 0.0)(eq d-n-2000-5000 1000.0))
	 (setq nam3 ""))
	((and (eq d-e-2000-5000 1000.0)(eq d-n-2000-5000 1000.0))
	 (setq nam3 ""))
	((and (eq d-e-2000-5000 0.0)(eq d-n-2000-5000 0.0))
	 (setq nam3 ""))
	((and (eq d-e-2000-5000 1000.0)(eq d-n-2000-5000 0.0))
	 (setq nam3 ""))
      )
      
      (setq nam4 (analisis-nomenclature-3ch-for-m500-un n e))
      
      (strcat nam1 "-" nam2 "-" nam3 "-"nam4)
      
      )
    )
  )
;;;(defun C:test-analisis-nomenclature-full-for-m500-msk-saratov ( / point)
;;;  (setq point (analisis-insert-point-planset-left-down-point (getpoint)250.0))
;;;  (terpri)
;;;  (princ(analisis-nomenclature-full-for-m500-msk-saratov point))
;;;  (princ)
;;;  )