(defun calculation-bl-to-xy-gaus (B_ L_ L0 a b / A0 A2 A2_ A4 A4_ A6 A6_ B1_ B3_ B5_ E2 E_2 L N NU X X_ Y)
  ;    x y   B L ( )
  ;(calculation-bl-to-xy-gaus (convert-grad-rad (+ 51.0 (/ 38.0 60.) (/ 43.9 3600.0))) (convert-grad-rad (+ 24.0 (/ 2.0 60.) (/ 13.136 3600.0))) (convert-grad-rad 27.0) 6378245.000 6356863.019)
;;;  (setq B_ (convert-grad-rad (+ 51.0 (/ 38.0 60.) (/ 43.9 3600.0))))
;;;  (setq L_ (convert-grad-rad (+ 24.0 (/ 2.0 60.) (/ 13.136 3600.0))))
;;;  (setq L0 (convert-grad-rad 27.0))
;;;  (setq a 6378245.000)
;;;  (setq b 6356863.019)
  (setq l (- L_ L0))
  (setq e2 (/(-(expt a 2.0)(expt b 2.0))(expt a 2.0)))
  (setq e_2 (/(-(expt a 2.0)(expt b 2.0))(expt b 2.0)))
  (setq N (/ a (expt(- 1.0 (* e2 (expt (sin B_) 2.0)))0.5)))
  (setq nu (* (sqrt e_2) (cos B_)))
  (setq a2_ (* 0.5 N (sin B_) (cos B_)))
  (setq a4_ (* (* (/ 1.0 24.0) N (sin B_)(expt (cos B_) 3.0))(+(- 5.0 (expt (tg B_) 2.0))(* 9.0 (expt nu 2.0))(* 4.0 (expt nu 4.0)))))
  (setq a6_ (*(* (/ 1.0 720.0) N (sin B_)(expt (cos B_) 5.0))
	      (-(+(- 61.0 (* 58.0 (expt (tg B_) 2.0)))(expt (tg B_) 4.0)(* 270.0 (expt nu 2.0)))(* 330.0 (expt nu 2.0)(expt (tg B_) 2.0)))
	      )
	)
  (setq b1_ (* N (cos B_)))
  (setq b3_ (* (/ 1.0 6.0) N (expt (cos B_) 3.0)(+(- 1.0 (expt (tg B_) 2.0))(expt nu 2.0))))
  (setq b5_ (*(/ 1.0 120.0)N (expt (cos B_) 5.0)(-(+(- 5.0 (* 18.0(expt (tg B_) 2.0)))(expt (tg B_) 4.0)(* 14.0 (expt nu 2.0)))(* 58.0 (expt nu 2.0)(expt (tg B_) 2.0)))))
  
  (setq A0 (* a (- 1 e2)(+ 1 (* (/ 3.0 4.0) e2) (* (/ 45.0 64.0) (expt e2 2))(* (/ 175.0 256.0) (expt e2 3)))))
  (setq A2 (* a (- 1 e2)(+ (* (/ 3.0 4.0) e2) (* (/ 15.0 16.0) (expt e2 2))(* (/ 525.0 512.0) (expt e2 3)))))
  (setq A4 (* a (- 1 e2)(+ (* (/ 15.0 64.0) (expt e2 2)) (* (/ 105.0 256.0) (expt e2 3)))))
  (setq A6 (* a (- 1 e2)(* (/ 35.0 512.0) (expt e2 3))))
  
  (setq X_ (-(+(- (* A0 B_) (* (/ A2 2.0) (sin (* B_ 2.0))))(* (/ A4 4.0) (sin (* B_ 4.0))))(* (/ A6 6.0) (sin (* B_ 6.0)))))
  (setq x (+ X_ (* a2_ (expt l 2.0))(* a4_ (expt l 4.0))(* a6_ (expt l 6.0))))
  (setq y (+ (* b1_ l)(* b3_ (expt l 3.0))(* b5_ (expt l 5.0))))
  (list y x)
  )

;;;(rtos(car(calculation-bl-to-xy-gaus
;;;  (convert-grad-rad (+ 55.0 (/ 40.0 60.0)))
;;;  (convert-grad-rad (+ 37.0 (/ 30.0 60.0)))
;;;  (convert-grad-rad (+ 37.0 (/ 30.0 60.0)))
;;;  6377397.155
;;;  6356078.963))2 3)