(defun create-map-list (file-name b1 l1 b2 l2 b3 l3 b4 l4 scale face)
  (list
    "OziExplorer Map Data File Version 2.2"
    (strcat file-name".png")
    (strcat file-name".png")
    "1 ,Map Code,"
    "WGS 84,,   0.0000,   0.0000,WGS 84"
    "Reserved 1"
    "Reserved 2"
    "Magnetic Variation,,,E"
    "Map Projection,Mercator,PolyCal,No,AutoCalOnly,No,BSBUseWPX,No"
    (strcat"Point01,xy,    0, 0,in, deg, "(convert-dec-to-dd_mm-print_to_png_area b1)",N, "(convert-dec-to-dd_mm-print_to_png_area l1)",E, grid,   ,           ,           ,N")
    (strcat"Point02,xy,    "face", 0,in, deg, "(convert-dec-to-dd_mm-print_to_png_area b2)",N, "(convert-dec-to-dd_mm-print_to_png_area l2)",E, grid,   ,           ,           ,N")
    (strcat"Point03,xy,    "face", "face",in, deg, "(convert-dec-to-dd_mm-print_to_png_area b3)",N, "(convert-dec-to-dd_mm-print_to_png_area l3)",E, grid,   ,           ,           ,N")
    (strcat"Point04,xy,    0, "face",in, deg, "(convert-dec-to-dd_mm-print_to_png_area b4)",N, "(convert-dec-to-dd_mm-print_to_png_area l4)",E, grid,   ,           ,           ,N")
    "Point05,xy,     ,     ,in, deg,    ,        ,N,    ,        ,W, grid,   ,           ,           ,N"
    "Point06,xy,     ,     ,in, deg,    ,        ,N,    ,        ,W, grid,   ,           ,           ,N"
    "Point07,xy,     ,     ,in, deg,    ,        ,N,    ,        ,W, grid,   ,           ,           ,N"
    "Point08,xy,     ,     ,in, deg,    ,        ,N,    ,        ,W, grid,   ,           ,           ,N"
    "Point09,xy,     ,     ,in, deg,    ,        ,N,    ,        ,W, grid,   ,           ,           ,N"
    "Point10,xy,     ,     ,in, deg,    ,        ,N,    ,        ,W, grid,   ,           ,           ,N"
    "Point11,xy,     ,     ,in, deg,    ,        ,N,    ,        ,W, grid,   ,           ,           ,N"
    "Point12,xy,     ,     ,in, deg,    ,        ,N,    ,        ,W, grid,   ,           ,           ,N"
    "Point13,xy,     ,     ,in, deg,    ,        ,N,    ,        ,W, grid,   ,           ,           ,N"
    "Point14,xy,     ,     ,in, deg,    ,        ,N,    ,        ,W, grid,   ,           ,           ,N"
    "Point15,xy,     ,     ,in, deg,    ,        ,N,    ,        ,W, grid,   ,           ,           ,N"
    "Point16,xy,     ,     ,in, deg,    ,        ,N,    ,        ,W, grid,   ,           ,           ,N"
    "Point17,xy,     ,     ,in, deg,    ,        ,N,    ,        ,W, grid,   ,           ,           ,N"
    "Point18,xy,     ,     ,in, deg,    ,        ,N,    ,        ,W, grid,   ,           ,           ,N"
    "Point19,xy,     ,     ,in, deg,    ,        ,N,    ,        ,W, grid,   ,           ,           ,N"
    "Point20,xy,     ,     ,in, deg,    ,        ,N,    ,        ,W, grid,   ,           ,           ,N"
    "Point21,xy,     ,     ,in, deg,    ,        ,N,    ,        ,W, grid,   ,           ,           ,N"
    "Point22,xy,     ,     ,in, deg,    ,        ,N,    ,        ,W, grid,   ,           ,           ,N"
    "Point23,xy,     ,     ,in, deg,    ,        ,N,    ,        ,W, grid,   ,           ,           ,N"
    "Point24,xy,     ,     ,in, deg,    ,        ,N,    ,        ,W, grid,   ,           ,           ,N"
    "Point25,xy,     ,     ,in, deg,    ,        ,N,    ,        ,W, grid,   ,           ,           ,N"
    "Point26,xy,     ,     ,in, deg,    ,        ,N,    ,        ,W, grid,   ,           ,           ,N"
    "Point27,xy,     ,     ,in, deg,    ,        ,N,    ,        ,W, grid,   ,           ,           ,N"
    "Point28,xy,     ,     ,in, deg,    ,        ,N,    ,        ,W, grid,   ,           ,           ,N"
    "Point29,xy,     ,     ,in, deg,    ,        ,N,    ,        ,W, grid,   ,           ,           ,N"
    "Point30,xy,     ,     ,in, deg,    ,        ,N,    ,        ,W, grid,   ,           ,           ,N"
    "Projection Setup,,,,,,,,,,"
    "Map Feature = MF ; Map Comment = MC     These follow if they exist"
    "Track File = TF      These follow if they exist"
    "Moving Map Parameters = MM?    These follow if they exist"
    "MM0,Yes"
    "MMPNUM,4"
    "MMPXY,1,0,0"
    (strcat"MMPXY,2,"face",0")
    (strcat"MMPXY,3,"face","face)
    (strcat"MMPXY,4,0,"face)
    (strcat"MMPLL,1, "(rtos b1 2 6)", "(rtos l1 2 6))
    (strcat"MMPLL,2, "(rtos b2 2 6)", "(rtos l2 2 6))
    (strcat"MMPLL,3, "(rtos b3 2 6)", "(rtos l3 2 6))
    (strcat"MMPLL,4, "(rtos b4 2 6)", "(rtos l4 2 6))
    (strcat"MM1B,"(rtos scale 2 6))
    "MOP,Map Open Position,0,0"
    (strcat"IWH,Map Image Width/Height,"face","face)
    )
  )