(defun dialog-print_to_png_area (/ list-CustomSYS list-DATUMsToWGS84 dcl_id dialog)
  (setq put-ini-folder (file-dat-xml-read variable "c:\\archaeoSYS\\"))
  (setq list-CustomSYS (_lispru-ini-datas-read1 (strcat put-ini-folder "CustomSYS.ini")))
  (setq list-DATUMsToWGS84 (_lispru-ini-datas-read1 (strcat put-ini-folder "DATUMsToWGS84.ini")))
  (setq dialog-print-to-png-area (vlax-ldata-get "geo_tools-data-dialogs" "dialog-print-to-png-area"))
  (if (not dialog-print-to-png-area)
    (setq dialog-print-to-png-area (list "0" "0")))
  (setq dcl_id (geo-tools-load-dialog "dialog_print_to_png_area"))
  (new_dialog "dialog_print_to_png_area" dcl_id)
  (set_tile "put_put_ini_folder" put-ini-folder)
  (start_list "sk")
  (foreach x list-CustomSYS (add_list (car x)))
  (end_list)
  (start_list "datum")
  (foreach x list-DATUMsToWGS84 (add_list (car x)))
  (end_list)
  (set_tile "sk" (nth 0 dialog-print-to-png-area))
  (set_tile "datum" (nth 1 dialog-print-to-png-area))
  
  (action_tile "sk"
    (vl-prin1-to-string
      '(progn
	(setq dialog-print-to-png-area (list $value (nth 1 dialog-print-to-png-area)))
	)
      ))
  
  (action_tile "datum"
    (vl-prin1-to-string
      '(progn
	(setq dialog-print-to-png-area (list (nth 0 dialog-print-to-png-area) $value))
	)
      ))
  
  (if (/= (start_dialog) 0)
    (progn
      (vlax-ldata-put "geo_tools-data-dialogs" "dialog-print-to-png-area" dialog-print-to-png-area)
      (list (nth (atoi(nth 0 dialog-print-to-png-area)) list-CustomSYS) (nth (atoi(nth 1 dialog-print-to-png-area)) list-DATUMsToWGS84))
      )
    )
  
  )