(defun C:draw_kartogramma_by_numenklature500 (/ file file-name insert-point list_files)
  ;       (- 1:500)  
  (setq list_files (file_find_be_extension "a:\\\\_maps\\\\\\500\\3 rename\\" "tif"))
  (foreach file list_files
    (setq file-name (vl-filename-base file))
    (setq insert-point (get-point-by_numenklature500-msk-saratov file-name))
    (draw-lwpolyline-vla-by-list-property
      (list(cons "spece" (if (eq (getvar "CTAB")"Model")model_spece paper_spece))
	   (cons "Coordinates" (list
				 insert-point
				 (mapcar '+ insert-point (list 250.0 0.0))
				 (mapcar '+ insert-point (list 250.0 250.0))
				 (mapcar '+ insert-point (list 0.0 250.0))
				 ))
		 (cons "Closed" -1)
	   ))
    (if (not insert-point)(princ file-name))
    (draw-mtext-vla-by-list-property
      (list
	(cons "spece" (if (eq (getvar "CTAB")"Model")model_spece paper_spece))
	(cons "TextString" file-name)
	(cons "InsertionPoint" (mapcar '+ insert-point (list 125.0 125.0)))
	(cons "Width" 250)
	(cons "Height" 30)
	(cons "Rotation" 0)
	(cons "AttachmentPoint" 5)
	))
    )
  (princ)
  )
