(defun C:draw_kartogramma_by_numenklature5000 (/ file-name insert-point list_files)
  ;       (- 1:5000)  
  (setq list_files (file_find_be_extension "d:\\005k" "bmp"))
  (foreach file list_files
    (setq file-name (vl-filename-base file))
    (setq insert-point (get-point-by_numenklature5000 file-name))
    (draw-lwpolyline-vla-by-list-property
      (list(cons "spece" (if (eq (getvar "CTAB")"Model")model_spece paper_spece))
	   (cons "Coordinates" (list
				 insert-point
				 (mapcar '+ insert-point (list 2000.0 0.0))
				 (mapcar '+ insert-point (list 2000.0 2000.0))
				 (mapcar '+ insert-point (list 0.0 2000.0))
				 ))
		 (cons "Closed" -1)
	   ))
    (if (not insert-point)(princ file-name))
    (draw-mtext-vla-by-list-property
      (list
	(cons "spece" (if (eq (getvar "CTAB")"Model")model_spece paper_spece))
	(cons "TextString" file-name)
	(cons "InsertionPoint" (mapcar '+ insert-point (list 1000.0 1000.0)))
	(cons "Width" 2000)
	(cons "Height" 200)
	(cons "Rotation" 0)
	(cons "AttachmentPoint" 5)
	))
    )
  (princ)
  )