(defun C:inport_file_to_be_acad_points( / FILENAME FILE_POINTS_LIST LIST-DIALOG PUT-FILE)
  (load_global_variable)
;;;  (setq list-dialog (dialog-import-acad-points))
  (setq list-dialog
	 (list
	   (list "point" "1")
	   (list "number" "1")
	   (list "elevation" "1")
	   (list "3d" "1")
	   ))
  (if list-dialog
    (progn
      (if(setq put-file (getfiled "  " (getvar "DWGPREFIX")  "txt" 0))
	(princ(setq file_points_list(get-GeodesistPENZD-katalog-coor put-file))))
      (if put-file
	(if file_points_list
	  (progn
	    (vla-StartUndoMark active_document)
	    (setq FileName(vl-string-translate "," "."(vl-filename-base put-file)))
	    (foreach x file_points_list
	      (if (= (get-item-by-name-in-list list-dialog "point") "1")
		(draw-point-vla-by-list-property
		  (list
		    (cons "spece" (if (eq (getvar "CTAB")"Model")model_spece paper_spece))
		    (cons "Coordinates" (list (get-item-by-name-in-list x "E")
					      (get-item-by-name-in-list x "N")
					      (if(= (get-item-by-name-in-list list-dialog "3d") "1")
						(get-item-by-name-in-list x "Z")
						0.0)))
		    )))
	      (if (= (get-item-by-name-in-list list-dialog "elevation") "1")
		(draw-text-vla-by-list-property
		  (list
		    (cons "spece" (if (eq (getvar "CTAB")"Model")model_spece paper_spece))
		    (cons "TextString" (strcat" "(rtos (get-item-by-name-in-list x "Z") 2 2)))
		    (cons "InsertionPoint" (list (get-item-by-name-in-list x "E")
						 (get-item-by-name-in-list x "N")
						 (if(= (get-item-by-name-in-list list-dialog "3d") "1")
						   (get-item-by-name-in-list x "Z")
						   0.0)))
		    (cons "Height" (/ 2.0 (format_scale_kof)))
		    (cons "Rotation" 0.0)
		    
		    (cons "Alignment" 9)
		    ))
		)
	      (if (= (get-item-by-name-in-list list-dialog "number") "1")
		(draw-text-vla-by-list-property
		  (list
		    (cons "spece" (if (eq (getvar "CTAB")"Model")model_spece paper_spece))
		    (cons "TextString" (strcat (get-item-by-name-in-list x "name")" "))
		    (cons "InsertionPoint" (list (get-item-by-name-in-list x "E")
						 (get-item-by-name-in-list x "N")
						 (if(= (get-item-by-name-in-list list-dialog "3d") "1")
						   (get-item-by-name-in-list x "Z")
						   0.0)))
		    (cons "Height" (/ 2.0 (format_scale_kof)))
		    (cons "Rotation" 0.0)
		    
		    (cons "Alignment" 11)
		    ))
		)
	      
	      
	      )
	    (vla-EndUndoMark active_document)
	    )
	  (alert "     !")
	  ))
      )
    (alert "!")
    )
  (princ)
  )