(defun C:create-vinos-page ( / Rotation paper_spece viewport block_center viewport_center_in_model target_p_usl_z_m_mg ;n
			    name_layout new_layout number-obj pline spisok nn p p1 p3 x dir-angle num_row t0 table_obj 2Dpline_vla)
  (load_global_variable)
  (initget 1)(setq pline (car (entsel "\n : ")))
  (cond
    ((eq pline nil)
     (alert "  !"))
    ((not(eq (cdr(assoc 0 (entget pline))) "LWPOLYLINE"))
     (alert "  2D !"))
    ((eq (cdr(assoc 0 (entget pline))) "LWPOLYLINE")
     (initget 1)(setq number-obj (car (entsel "\n : ")))
     
     (setq name_layout (vl-string-trim ":"(cdr (assoc 1 (entget number-obj)))))
     (setq 2Dpline_vla (vlax-ename->vla-object pline))
     (setq spisok (extract_coord_lwpolyline (entget pline)))
;;;     (setq n 1)
     (setq nn 1)
     (create-or-sel-layer name_layout)
     (foreach x spisok;    
		(cond ;    
		  ((eq (vl-position x spisok) 0) ;    
		   (setq p1(nth (1-(length spisok)) spisok))
		   (setq p3(nth(1+(vl-position x spisok))spisok))
		   )
		  ((eq (vl-position x spisok) (1-(length spisok)));    
		   (setq p1(nth(1-(vl-position x spisok))spisok))
		   (setq p3(nth 0 spisok))
		   )
		  (T ;    
		   (setq p1(nth(1-(vl-position x spisok))spisok))
		   (setq p3(nth(1+(vl-position x spisok))spisok))
		   )
		  )
		(cond;    
		  ((> (calculation_angle_be_3points p1 x p3) (calculation_angle_be_3points p3 x p1))
		   (setq p (polar x (+(angle x p3) (/(calculation_angle_be_3points p1 x p3)2)) (/ 5 (getvar "CANNOSCALEVALUE")))))
		  ((< (calculation_angle_be_3points p1 x p3) (calculation_angle_be_3points p3 x p1))
		   (setq p (polar x (+(angle x p1) (/(calculation_angle_be_3points p3 x p1)2)) (/ 5 (getvar "CANNOSCALEVALUE")))))
		  ((= (calculation_angle_be_3points p1 x p3) (calculation_angle_be_3points p3 x p1))
		   (setq p (polar x (+(angle x p3) (/ pi 2)) (/ 5 (getvar "CANNOSCALEVALUE"))))))
		
		(draw-text-vla-by-list-property
		  (list
		    (cons "spece" (if (eq (getvar "CTAB")"Model")model_spece paper_spece))
		    (cons "TextString" (strcat ""(rtos nn 2 0)))
		    (cons "InsertionPoint" p)
		    (cons "Height" (/ 3 (getvar "CANNOSCALEVALUE")))
		    (cons "Rotation" 0)
		    (cons "Alignment" 4)
		    ))
		
		(draw-insertblock-vla-by-list-property
		  (list(cons "spece" (if (eq (getvar "CTAB")"Model")model_spece paper_spece))
		       (cons "InsertionPoint" x)
		       (cons "EffectiveName" "")
		       (cons "XScaleFactor" 2.0)
		       (cons "YScaleFactor" 2.0)
		       (cons "ZScaleFactor" 2.0)
		       (cons "Rotation" 0.0)
		       ))
       (setq nn (1+ nn))
		);   
     (if (eq (vla-get-LayoutCreateViewport(vla-get-Display(vla-get-Preferences acad_application))) :vlax-true)
       (vla-put-LayoutCreateViewport(vla-get-Display(vla-get-Preferences acad_application)) :vlax-false))
     (setq Rotation 0.0)
     (setq new_layout (vla-add layouts_document name_layout));   
     (vla-put-ActiveLayout active_document new_layout);   
     (setq paper_spece (vla-get-PaperSpace active_document));    
     (draw-insertblock-vla-by-list-property
       (list(cons "spece" (if (eq (getvar "CTAB")"Model")model_spece paper_spece))
	    (cons "InsertionPoint" '(-0.794 -0.794 0))
	    (cons "EffectiveName" " A4 297x210")
	    (cons "XScaleFactor" 1.0)
	    (cons "YScaleFactor" 1.0)
	    (cons "ZScaleFactor" 1.0)
	    (cons "Rotation" 0.0)
	    ))
     (setq viewport (vla-AddPViewport paper_spece (vlax-3D-point (list 111.706 216.956 0)) 175.0 138.5));   
     (vla-put-CustomScale viewport 1.0)
     (vla-put-Layer viewport " ")
     (setq block_center (cdr (assoc 11 (entget number-obj))))
     (setq viewport_center_in_model (cdr (assoc 12 (entget (vlax-vla-object->ename viewport)))))
     (setq target_p_usl_z_m_mg (polar(polar block_center (- Rotation (/ pi 2)) (cadr viewport_center_in_model))
				     (- Rotation pi) (car viewport_center_in_model)))
     (vla-put-Target viewport (vlax-3D-point target_p_usl_z_m_mg))
     (vla-put-TwistAngle viewport (-(* pi 2)Rotation))
     (vla-put-ViewportOn viewport :vlax-true)
     
     (setq nn 1)
     (setq t0 (list 57.706 142.7 0.0))
            (setq table_obj (vla-AddTable paper_spece (vlax-3D-point t0) 2 5 12 25))
       (vla-put-StyleName table_obj "")
       (vla-SetColumnWidth table_obj 0 8)
       
       (vla-SetText table_obj 0 0 (strcat " " name_layout))
       (vla-SetCellTextHeight table_obj 0 0 4.0)
       (vla-SetCellAlignment table_obj 0 0 acMiddleCenter)
       
       (vla-SetText table_obj 1 0 "N")
       (vla-SetCellTextHeight table_obj 1 0 2.8)
       (vla-SetCellAlignment table_obj 1 0 acMiddleCenter)
       
       (vla-SetText table_obj 1 1 "X")
       (vla-SetCellAlignment table_obj 1 1 acMiddleCenter)
       (vla-SetCellTextHeight table_obj 1 1 2.8)
       
       (vla-SetText table_obj 1 2 "Y")
       (vla-SetCellAlignment table_obj 1 2 acMiddleCenter)
       (vla-SetCellTextHeight table_obj 1 2 2.8)
       
       (vla-SetText table_obj 1 3 "")
       (vla-SetCellAlignment table_obj 1 3 acMiddleCenter)
       (vla-SetCellTextHeight table_obj 1 3 2.8)
       
       (vla-SetText table_obj 1 4 ".")
       (vla-SetCellAlignment table_obj 1 4 acMiddleCenter)
       (vla-SetCellTextHeight table_obj 1 4 2.8)
       
       (vla-SetColumnWidth table_obj 4 25.0)
       (vla-put-horzcellmargin table_obj 0.5)
       (vla-put-vertcellmargin table_obj 0.5)
       (vla-SetRowHeight table_obj 1 12.0)
       
     (foreach x spisok;    

       (setq num_row (vla-get-rows table_obj));    
       ;   
       (vla-InsertRows table_obj (1+ num_row) 4 2)
       (vla-SetRowHeight table_obj (1+ num_row) 5.2)
       (vla-mergeCells table_obj num_row (1+ num_row) 0 0)
       (vla-mergeCells table_obj num_row (1+ num_row) 1 1)
       (vla-mergeCells table_obj num_row (1+ num_row) 2 2)
       
       (vla-SetText table_obj num_row 0 (strcat ""(rtos nn 2 0)))
       (vla-SetCellAlignment table_obj num_row 0 acMiddleCenter)
       (vla-SetCellTextHeight table_obj num_row 0 2.8)
       
       (vla-SetText table_obj num_row 1 (rtos (nth 1 x) 2 2))
       (vla-SetCellAlignment table_obj num_row 1 acMiddleCenter)
       (vla-SetCellTextHeight table_obj num_row 1 2.8)
       
       (vla-SetText table_obj num_row 2 (rtos (nth 0 x) 2 2))
       (vla-SetCellAlignment table_obj num_row 2 acMiddleCenter)
       (vla-SetCellTextHeight table_obj num_row 2 2.8)
       
       (vla-SetRowHeight table_obj (1+ num_row) 5.0)
       (vla-SetRowHeight table_obj num_row 5.0)
       
       ;  .
       (if (not(eq (vl-position x spisok) 0));    
	 (progn
	   (setq p1(nth(1-(vl-position x spisok))spisok))
	   (if(> nn (length spisok)); 
	     (progn
	       
	       )
	     (progn;  
	       
	       (vla-mergeCells table_obj (1- num_row) num_row 3 3)
	       (vla-SetText table_obj (1- num_row) 3 (rtos(distance x p1)2 2))
	       (vla-SetCellAlignment table_obj (1- num_row) 3 acMiddleCenter)
	       (vla-SetCellTextHeight table_obj (1- num_row) 3 2.8)
	       ; .
	       (if (or (>(setq dir-angle(+(/ pi 2)(-(* pi 2)(angle p1 x))))(* pi 2))(= dir-angle (* pi 2)))
		 (setq dir-angle (- dir-angle(* pi 2))))
	       (vla-mergeCells table_obj (1- num_row) num_row 4 4)
	       (vla-SetText table_obj (1- num_row) 4 (vl-string-subst"%%d" "d"(convert-dec-to-gms-str (convert-rad-grad dir-angle) 2)0))
	       (vla-SetCellAlignment table_obj (1- num_row) 4 acMiddleCenter)
	       (vla-SetCellTextHeight table_obj (1- num_row) 4 2.8)
	       )
	     )
	   )
	 )
       (vla-SetCellGridVisibility table_obj (1+ num_row) 0 acBottomMask :vlax-false)
       (vla-SetCellGridVisibility table_obj (1+ num_row) 1 acBottomMask :vlax-false)
       (vla-SetCellGridVisibility table_obj (1+ num_row) 2 acBottomMask :vlax-false)
       (vla-SetCellGridVisibility table_obj num_row 3 acBottomMask :vlax-false)
       (vla-SetCellGridVisibility table_obj num_row 4 acBottomMask :vlax-false)

       (setq nn (1+ nn))
       );   
     	 (vla-InsertRows table_obj (+ num_row 2) 4 1)
	 (vla-SetRowHeight table_obj (+ num_row 2) 5.2)
	 
	 (vla-mergeCells table_obj (1+ num_row) (+ num_row 2) 3 3)
	 (vla-SetText table_obj (1+ num_row) 3 (rtos(distance (nth (1-(length spisok)) spisok) (nth 0 spisok))2 2))
	 (vla-SetCellAlignment table_obj (1+ num_row) 3 acMiddleCenter)
	 (vla-SetCellTextHeight table_obj (1+ num_row) 3 2.8)
	 
	 (vla-mergeCells table_obj (1+ num_row) (+ num_row 2) 4 4)
	 (vla-SetText table_obj (1+ num_row) 4 (vl-string-subst"%%d" "d"(convert-dec-to-gms-str (convert-rad-grad(angle (nth (1-(length spisok)) spisok) (nth 0 spisok))) 2)0))
	 (vla-SetCellAlignment table_obj (1+ num_row) 4 acMiddleCenter)
	 (vla-SetCellTextHeight table_obj (1+ num_row) 4 2.8)
	 
	 (setq num_row (vla-get-rows table_obj))
	 (vla-InsertRows table_obj (1+ num_row) 8 1)
	 (vla-mergeCells table_obj num_row num_row 0 2)
	 (vla-mergeCells table_obj num_row num_row 3 4)
	 (vla-SetText table_obj num_row 0 (strcat " "(rtos (vla-get-Length 2Dpline_vla) 2 0) " "))
	 (vla-SetCellTextHeight table_obj num_row 0 2.4)
	 (vla-SetCellAlignment table_obj num_row 0 acMiddleCenter)
	 (vla-SetText table_obj num_row 3 (strcat "  "(rtos (vla-get-Area 2Dpline_vla) 2 0) " .."))
	 (vla-SetCellTextHeight table_obj num_row 3 2.4)
	 (vla-SetRowHeight table_obj num_row 8.0)
	 (vla-SetCellAlignment table_obj num_row 3 acMiddleCenter)
	 (vla-SetCellGridVisibility table_obj num_row 2 acRightMask :vlax-false)
;;;	 (vla-ScaleEntity table_obj (vlax-3D-point t0) (/ 1 (getvar "CANNOSCALEVALUE")))
     )
    )
  (princ)
  )

;;;((eq (cdr(assoc 0 (entget pline))) "LWPOLYLINE")
;;;     (vla-StartUndoMark active_document)
;;;     (create-table-style);    
;;;     (setq 2Dpline_vla (vlax-ename->vla-object pline))
;;;     (setq spisok (extract_coord_lwpolyline (entget pline)))
;;;     
;;;     (if(setq t0 (getpoint "\n     <>: "))
;;;       (progn
;;;	 (setq table_obj (vla-AddTable model_spece (vlax-3D-point t0) 2 5 12 20))
;;;	 (vla-put-StyleName table_obj "")
;;;	 (vla-SetColumnWidth table_obj 0 8)
;;;	 
;;;	 (vla-SetText table_obj 0 0 "")
;;;	 (vla-SetCellTextHeight table_obj 0 0 4.0)
;;;	 (vla-SetCellAlignment table_obj 0 0 acMiddleCenter)
;;;	 
;;;	 (vla-SetText table_obj 1 0 "N")
;;;	 (vla-SetCellTextHeight table_obj 1 0 2.8)
;;;	 (vla-SetCellAlignment table_obj 1 0 acMiddleCenter)
;;;	 
;;;	 (vla-SetText table_obj 1 1 "X")
;;;	 (vla-SetCellAlignment table_obj 1 1 acMiddleCenter)
;;;	 (vla-SetCellTextHeight table_obj 1 1 2.8)
;;;	 
;;;	 (vla-SetText table_obj 1 2 "Y")
;;;	 (vla-SetCellAlignment table_obj 1 2 acMiddleCenter)
;;;	 (vla-SetCellTextHeight table_obj 1 2 2.8)
;;;	 
;;;	 (vla-SetText table_obj 1 3 "")
;;;	 (vla-SetCellAlignment table_obj 1 3 acMiddleCenter)
;;;	 (vla-SetCellTextHeight table_obj 1 3 2.8)
;;;	 
;;;	 (vla-SetText table_obj 1 4 ".")
;;;	 (vla-SetCellAlignment table_obj 1 4 acMiddleCenter)
;;;	 (vla-SetCellTextHeight table_obj 1 4 2.8)
;;;	 
;;;	 (vla-SetColumnWidth table_obj 4 25.0)
;;;	 (vla-put-horzcellmargin table_obj 0.5)
;;;	 (vla-put-vertcellmargin table_obj 0.5)
;;;	 (vla-SetRowHeight table_obj 1 12.0)
;;;;;;	 (setq ss (ssadd))
;;;	 (setq nn 1)
;;;	 (mapcar '(lambda (x);    
;;;		    (cond ;    
;;;		      ((eq (vl-position x spisok) 0) ;    
;;;		       (setq p1(nth (1-(length spisok)) spisok))
;;;		       (setq p3(nth(1+(vl-position x spisok))spisok))
;;;		       )
;;;		      ((eq (vl-position x spisok) (1-(length spisok)));    
;;;		       (setq p1(nth(1-(vl-position x spisok))spisok))
;;;		       (setq p3(nth 0 spisok))
;;;		       )
;;;		      (T ;    
;;;		       (setq p1(nth(1-(vl-position x spisok))spisok))
;;;		       (setq p3(nth(1+(vl-position x spisok))spisok))
;;;		       )
;;;		      )
;;;		    (cond;    
;;;		      ((> (calculation_angle_be_3points p1 x p3) (calculation_angle_be_3points p3 x p1))
;;;		       (setq p (polar x (+(angle x p3) (/(calculation_angle_be_3points p1 x p3)2)) (/ 5 (getvar "CANNOSCALEVALUE")))))
;;;		      ((< (calculation_angle_be_3points p1 x p3) (calculation_angle_be_3points p3 x p1))
;;;		       (setq p (polar x (+(angle x p1) (/(calculation_angle_be_3points p3 x p1)2)) (/ 5 (getvar "CANNOSCALEVALUE")))))
;;;		      ((= (calculation_angle_be_3points p1 x p3) (calculation_angle_be_3points p3 x p1))
;;;		       (setq p (polar x (+(angle x p3) (/ pi 2)) (/ 5 (getvar "CANNOSCALEVALUE"))))))
;;;		    
;;;		    (draw-text-vla-by-list-property
;;;			 (list
;;;			   (cons "spece" (if (eq (getvar "CTAB")"Model")model_spece paper_spece))
;;;			   (cons "TextString" (strcat ""(rtos nn 2 0)))
;;;			   (cons "InsertionPoint" p)
;;;			   (cons "Height" (/ 3 (getvar "CANNOSCALEVALUE")))
;;;			   (cons "Rotation" 0)
;;;			   (cons "Alignment" 4)
;;;			   ))
;;;
;;;		    (draw-insertblock-vla-by-list-property
;;;		      (list(cons "spece" (if (eq (getvar "CTAB")"Model")model_spece paper_spece))
;;;			   (cons "InsertionPoint" x)
;;;			   (cons "EffectiveName" "")
;;;			   (cons "XScaleFactor" 2.0)
;;;			   (cons "YScaleFactor" 2.0)
;;;			   (cons "ZScaleFactor" 2.0)
;;;			   (cons "Rotation" 0.0)
;;;			   ))
;;;		    
;;;;;;		    (ssadd (entlast) ss)
;;;;;;		    (setvar "CMDECHO" 0)
;;;;;;		    
;;;;;;		    (vl-cmdf "-objectscale" ss "" "_Add" (getvar "CANNOSCALE") "")
;;;;;;		    (command)
;;;;;;		    (setvar "CMDECHO" 1)
;;;;;;		    
;;;;;;		    (ssdel (ssname ss 0) ss)
;;;		    
;;;		    (setq num_row (vla-get-rows table_obj));    
;;;		    ;   
;;;		    (vla-InsertRows table_obj (1+ num_row) 4 2)
;;;		    (vla-SetRowHeight table_obj (1+ num_row) 5.2)
;;;		    (vla-mergeCells table_obj num_row (1+ num_row) 0 0)
;;;		    (vla-mergeCells table_obj num_row (1+ num_row) 1 1)
;;;		    (vla-mergeCells table_obj num_row (1+ num_row) 2 2)
;;;		    
;;;		    (vla-SetText table_obj num_row 0 (strcat ""(rtos nn 2 0)))
;;;		    (vla-SetCellAlignment table_obj num_row 0 acMiddleCenter)
;;;		    (vla-SetCellTextHeight table_obj num_row 0 2.8)
;;;		    
;;;		    (vla-SetText table_obj num_row 1 (rtos (nth 1 x) 2 2))
;;;		    (vla-SetCellAlignment table_obj num_row 1 acMiddleCenter)
;;;		    (vla-SetCellTextHeight table_obj num_row 1 2.8)
;;;		    
;;;		    (vla-SetText table_obj num_row 2 (rtos (nth 0 x) 2 2))
;;;		    (vla-SetCellAlignment table_obj num_row 2 acMiddleCenter)
;;;		    (vla-SetCellTextHeight table_obj num_row 2 2.8)
;;;		    
;;;		    (vla-SetRowHeight table_obj (1+ num_row) 5.0)
;;;		    (vla-SetRowHeight table_obj num_row 5.0)
;;;		    
;;;		    ;  .
;;;		    (if (not(eq (vl-position x spisok) 0));    
;;;		      (progn
;;;			(setq p1(nth(1-(vl-position x spisok))spisok))
;;;			(if(> nn (length spisok)); 
;;;			  (progn
;;;
;;;			    )
;;;			  (progn
;;;			    ;  
;;;			    (vla-mergeCells table_obj (1- num_row) num_row 3 3)
;;;			    (vla-SetText table_obj (1- num_row) 3 (rtos(distance x p1)2 2))
;;;			    (vla-SetCellAlignment table_obj (1- num_row) 3 acMiddleCenter)
;;;			    (vla-SetCellTextHeight table_obj (1- num_row) 3 2.8)
;;;			    ; .
;;;			    (if (or (>(setq dir-angle(+(/ pi 2)(-(* pi 2)(angle p1 x))))(* pi 2))(= dir-angle (* pi 2)))
;;;			      (setq dir-angle (- dir-angle(* pi 2))))
;;;			    (vla-mergeCells table_obj (1- num_row) num_row 4 4)
;;;			    (vla-SetText table_obj (1- num_row) 4 (vl-string-subst"%%d" "d"(convert-dec-to-gms-str (convert-rad-grad dir-angle) 2)0))
;;;			    (vla-SetCellAlignment table_obj (1- num_row) 4 acMiddleCenter)
;;;			    (vla-SetCellTextHeight table_obj (1- num_row) 4 2.8)
;;;			    )
;;;			  )
;;;			)
;;;		      )
;;;		    (vla-SetCellGridVisibility table_obj (1+ num_row) 0 acBottomMask :vlax-false)
;;;		    (vla-SetCellGridVisibility table_obj (1+ num_row) 1 acBottomMask :vlax-false)
;;;		    (vla-SetCellGridVisibility table_obj (1+ num_row) 2 acBottomMask :vlax-false)
;;;		    (vla-SetCellGridVisibility table_obj num_row 3 acBottomMask :vlax-false)
;;;		    (vla-SetCellGridVisibility table_obj num_row 4 acBottomMask :vlax-false)
;;;		    (setq nn (1+ nn))
;;;		    )
;;;		 spisok)
;;;	 (vla-InsertRows table_obj (+ num_row 2) 4 1)
;;;	 (vla-SetRowHeight table_obj (+ num_row 2) 5.2)
;;;	 
;;;	 (vla-mergeCells table_obj (1+ num_row) (+ num_row 2) 3 3)
;;;	 (vla-SetText table_obj (1+ num_row) 3 (rtos(distance (nth (1-(length spisok)) spisok) (nth 0 spisok))2 2))
;;;	 (vla-SetCellAlignment table_obj (1+ num_row) 3 acMiddleCenter)
;;;	 (vla-SetCellTextHeight table_obj (1+ num_row) 3 2.8)
;;;	 
;;;	 (vla-mergeCells table_obj (1+ num_row) (+ num_row 2) 4 4)
;;;	 (vla-SetText table_obj (1+ num_row) 4 (vl-string-subst"%%d" "d"(convert-dec-to-gms-str (convert-rad-grad(angle (nth (1-(length spisok)) spisok) (nth 0 spisok))) 2)0))
;;;	 (vla-SetCellAlignment table_obj (1+ num_row) 4 acMiddleCenter)
;;;	 (vla-SetCellTextHeight table_obj (1+ num_row) 4 2.8)
;;;	 
;;;	 (setq num_row (vla-get-rows table_obj))
;;;	 (vla-InsertRows table_obj (1+ num_row) 8 1)
;;;	 (vla-mergeCells table_obj num_row num_row 0 2)
;;;	 (vla-mergeCells table_obj num_row num_row 3 4)
;;;	 (vla-SetText table_obj num_row 0 (strcat " "(rtos (vla-get-Length 2Dpline_vla) 2 0) " "))
;;;	 (vla-SetCellTextHeight table_obj num_row 0 2.4)
;;;	 (vla-SetCellAlignment table_obj num_row 0 acMiddleCenter)
;;;	 (vla-SetText table_obj num_row 3 (strcat "  "(rtos (vla-get-Area 2Dpline_vla) 2 0) " .."))
;;;	 (vla-SetCellTextHeight table_obj num_row 3 2.4)
;;;	 (vla-SetRowHeight table_obj num_row 8.0)
;;;	 (vla-SetCellAlignment table_obj num_row 3 acMiddleCenter)
;;;	 (vla-SetCellGridVisibility table_obj num_row 2 acRightMask :vlax-false)
;;;	 (vla-ScaleEntity table_obj (vlax-3D-point t0) (/ 1 (getvar "CANNOSCALEVALUE")))
;;;	 )
;;;       )
;;;     (vla-EndUndoMark active_document)
;;;     )