(defun C:skv_interval (/ list-curent-skv list-file list-skv insert-point n current-skv block-obj f s temp txt vla-txt)
  (setq list-file (file_read_to_list "D:\\.txt"))
  
  (foreach x list-file
    (if (= "" (substr x 1 4))
      (progn
	(if list-curent-skv
	  (setq list-skv (append  list-skv (list list-curent-skv))))
	(setq list-curent-skv (list(car (convert-string-to-list-be-delimiter x ";"))))
	)
      (setq list-curent-skv (append  list-curent-skv (list (convert-string-to-list-be-delimiter x ";"))))
      )
    )
  (setq list-skv (append  list-skv (list list-curent-skv)))
;;;  (princ list-skv)
  (setq txt (car (entsel "\n  : ")))
  (setq vla-txt (vlax-ename->vla-object txt))
  (setq current-skv(cdr(assoc (vla-get-TextString vla-txt) list-skv)))
  (setq insert-point (vlax-safearray->list (vlax-variant-value (vla-get-TextAlignmentPoint vla-txt))))
  (vla-StartUndoMark active_document)
  (setq n 1)
  (foreach x current-skv
    (setq s (*(atof(vl-string-subst "." "," (nth 1 x)))10.0))
    (setq f (*(atof(vl-string-subst "." "," (nth 2 x)))10.0))
    (setq temp(vla-insertblock model_spece
		(vlax-3D-point (list (+(nth 0 insert-point)(if (zerop (rem n 2)) 0.5 -0.5)) (-(nth 1 insert-point)s)))
		"" 1.0 (- f s) 1.0 0))
    (setq n (1+ n))
    (draw-mtext-vla-by-list-property
      (list
	(cons "spece" (if (eq (getvar "CTAB")"Model")model_spece paper_spece))
	(cons "TextString" (strcat "=" (nth 3 x)
				   "\n,%=" (nth 4 x)
				   (if (/= (nth 5 x)"") (strcat "\n="(nth 5 x))"")
				   (if (/= (nth 6 x)"") (strcat "\nV="(nth 6 x))"")
				   )
	      )
	(cons "InsertionPoint" (list (+(nth 0 insert-point)3.0) (-(nth 1 insert-point)(+(/(- f s)2)s))))
	(cons "Width" 20)
	(cons "Height" 2.5)
	(cons "Rotation" 0)
	(cons "BackgroundFill" -1)
	(cons "AttachmentPoint" 4)
	))
    )
  (vla-EndUndoMark active_document)
  (princ)
  )