(defun C:draw_shelf_be_text (/ t1 text dtext t2 t3 mode input flag)
  (geo_tools-help "draw_shelf_be_text")
  (setq mode (vlax-ldata-get "geo_tools_dictionary" "draw_shelf_be_text"))
  (if (not mode) (setq mode ""))
  (while (if (/= input "")(setq t1(getpoint "\n : ")))
;;;    (princ t1)
    (setq flag nil)
    (while (not flag)
;;;      (princ mode)
      (initget "  ")
      (setq input (entsel (strcat
			    "\n ["
			    (if (= mode "") "" "")
			    "/]<"
			    (if (= mode "") "" "")
			    ">: ")))
;;;      (princ input)
      (cond
	((= input "")
	 (setq flag T)
	 (setq t1 nil)
	 )
	((= input "")
	 (setq mode "")
	 (vlax-ldata-put "geo_tools_dictionary" "draw_shelf_be_text" mode)
	 )
	((= input "")
	 (setq mode "")
	 (vlax-ldata-put "geo_tools_dictionary" "draw_shelf_be_text" mode)
	 )
	((= (type input) 'LIST)
	 (setq text(car input))
	 (setq flag T)
	 )
	((= input nil)
	 (princ "\n  .  .")
	 )
	)
      )
    (if (not (= input ""))
      (progn
	(setq dtext (calculation_text_height_be_dxf_code (entget text)))
	(setq t2 (polar
		   (polar (cdr (assoc 10 (entget text)))(-(cdr (assoc 50 (entget text)))(/ pi 2)) (/(cdr (assoc 40 (entget text)))4))
		   (+(cdr (assoc 50 (entget text)))pi)(/(cdr (assoc 40 (entget text)))4))
	      )
	(setq t3 (polar t2 (cdr (assoc 50 (entget text))) (+ dtext(/(cdr (assoc 40 (entget text)))2))))
	(if
	  (< (distance t1 t2) (distance t1 t3))
	  (if (= mode "")
	    (draw-lwpolyline-vla-by-list-property
	      (list(cons "spece" (if (eq (getvar "CTAB")"Model")model_spece paper_spece))
		   (cons "Coordinates" (list t1 t2 t3))
		   (cons "Layer"(cdr (assoc 8 (entget text))))
		   (cons "Linetype" "Continuous")
		   ))
	    (progn
	      (entmake (list '(0 . "LINE") '(6 . "Continuous") (assoc 8 (entget text))(append '(10) t1) (append '(11) t2)))
	      (entmake (list '(0 . "LINE") '(6 . "Continuous") (assoc 8 (entget text))(append '(10) t2) (append '(11) t3)))
	      )
	    )
	  (if (= mode "")
	    (draw-lwpolyline-vla-by-list-property
	      (list(cons "spece" (if (eq (getvar "CTAB")"Model")model_spece paper_spece))
		   (cons "Coordinates" (list t1 t3 t2))
		   (cons "Layer"(cdr (assoc 8 (entget text))))
		   (cons "Linetype" "Continuous")
		   ))
	    (progn
	      (entmake (list '(0 . "LINE") '(6 . "Continuous") (assoc 8 (entget text))(append '(10) t1) (append '(11) t3)))
	      (entmake (list '(0 . "LINE") '(6 . "Continuous") (assoc 8 (entget text))(append '(10) t3) (append '(11) t2)))
	      )
	    )
	  )
	)
      )
    )
  (princ)
  )
