(defun analisis-nomenclature-3ch-for-m500-un (input-n input-e / e n stb-e str-n)
  ;   ()      1:500
  ;   1:2000   16 
  ;|
       1  2  3  4
       5  6  7  8
       9 10 11 12
      13 14 15 16
  |;
  
  (setq n(fix(abs(rem input-n 1000))))
  (setq e(fix(abs(rem input-e 1000))))
  (setq stb-e
	 (if (minusp input-e)
	   (cond
	     ((= e 750) 2)
	     ((= e 500) 3)
	     ((= e 250) 4)
	     ((= e 0) 1)
	     )
	   (cond
	     ((= e 750) 4)
	     ((= e 500) 3)
	     ((= e 250) 2)
	     ((= e 0) 1)
	     )
	   )
	)
  (setq str-n
	 (if (minusp input-n)
	   (cond
	     ((= n 0) 12)
	     ((= n 750) 8)
	     ((= n 500) 4)
	     ((= n 250) 0)
	     )
	   (cond
	     ((= n 750) 0)
	     ((= n 500) 4)
	     ((= n 250) 8)
	     ((= n 0) 12)
	     )
	   )
	)
  (itoa (+ stb-e str-n))
  )

