(defun create-map-file (pach-folder point-1 krest-dist face convert-sys-property / point-2 point-3 point-4 map-list point-1-bl point-2-bl point-3-bl point-4-bl)
  (setq file-name (strcat (rtos(nth 1 point-1)2 3) "-" (rtos(nth 0 point-1)2 3)))
  (setq point-2 (mapcar '+ point-1 (list krest-dist 0.0 )))
  (setq point-3 (mapcar '+ point-1 (list krest-dist (* krest-dist -1.0))))
  (setq point-4 (mapcar '+ point-1 (list 0.0 (* krest-dist -1.0))))
  (setq point-1-bl(convert-xy-to-bl-wgs-84-by-property convert-sys-property point-1))
  (setq point-2-bl(convert-xy-to-bl-wgs-84-by-property convert-sys-property point-2))
  (setq point-3-bl(convert-xy-to-bl-wgs-84-by-property convert-sys-property point-3))
  (setq point-4-bl(convert-xy-to-bl-wgs-84-by-property convert-sys-property point-4))
  (setq map-list(create-map-list file-name
		  (nth 0 point-1-bl)(nth 1 point-1-bl)
		  (nth 0 point-2-bl)(nth 1 point-2-bl)
		  (nth 0 point-3-bl)(nth 1 point-3-bl)
		  (nth 0 point-4-bl)(nth 1 point-4-bl)
		  (/ krest-dist face) (itoa face)))
  (file_write_list_to_file (strcat pach-folder "\\" file-name ".map") map-list)
  )