(defun C:import-txt-xyz-wgs-84-to-cogo-point (/ put-file point-bl-coor-list point-coor point-obj dialog-var bl)
  ; 
  (if(setq put-file (getfiled "  " (getvar "DWGPREFIX")  "txt" 0))
    (progn
      (create-or-sel-layer (vl-filename-base put-file))
      (princ(setq point-bl-coor-list(get-txt-xyz-point-coor put-file)))
      (setq dialog-var(dialog-print_to_png_area))
      (foreach x point-bl-coor-list
	(setq bl (calculation-BLH-by-XYZ (list (nth 1 x)(nth 2 x)(nth 3 x)) 6378245.0 6356863.0))
	(setq point-coor(convert-bl-wgs-84-to-xy-by-property dialog-var bl))
	(setq point-obj (vla-add C3D_points(vlax-3d-point(nth 0 point-coor)(nth 1 point-coor)0.0)))
	(vlax-put-property point-obj 'Description (nth 0 x))
	))
    )
  (princ)
  )