(defun C:import-wpt-to-cogo-point (/ put-file point-bl-coor-list point-coor point-obj list-property)
  (if(setq put-file (getfiled "  " (getvar "DWGPREFIX")  "wpt" 0))
    (progn
      (setq list-property(dialog-print_to_png_area))
      (setq point-bl-coor-list(get-wpt-point-coor put-file))
      (foreach x point-bl-coor-list
	(setq point-coor(convert-bl-wgs-84-to-xy-by-property list-property (nth 1 x)))
	(setq point-obj (vla-add C3D_points(vlax-3d-point(nth 0 point-coor)(nth 1 point-coor)0.0)))
	(vlax-put-property point-obj 'Description (car x))
	))
    )
  (princ)
  )

(defun get-wpt-point-coor (put-file / list-file str str_list bl name list-points n)
  (setq list-file(file_read_to_list put-file))
  (setq n 4)
  (while (setq str (nth n list-file))
    (setq str_list (convert-string-to-list-be-delimiter str ","))
    (setq name (nth 1 str_list))
    (setq bl (list (atof(nth 2 str_list))(atof(nth 3 str_list))))
    (setq list-points (append list-points (list(list name bl))))
    (setq n (1+ n))
    )
  list-points
  )